﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Security;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace WSI_sample
{
    class Communication
    {
        private Data data;

        public Communication()
        {
            data = Data.getData();
        }

        public void get(Dictionary<String, String> parameters, AsyncCallback callback)
        {
            String url = data.getUrl();

            // Note: The GetEvents request has a different syntax.
            if (parameters["cmd"] == "GetEvents")
            {
                url += "/cgi-bin/gadgetapi/GetEvents?";
                parameters.Remove("cmd");
            }
            else
            {
                url += "/cgi-bin/gadgetapi?";
            }

            url += parametersToString(parameters);

            HttpWebRequest webRequest = (HttpWebRequest)WebRequest.Create(url);
            // The certificates are self-signed so you have to accept them manually.
            webRequest.ServerCertificateValidationCallback = ValidateServerCertificate;

            webRequest.BeginGetResponse(callback, webRequest);
        }

        // converts the Dictionary with the parameters to a string
        private String parametersToString(Dictionary<String, String> parameters)
        {
            String str = "";

            foreach (KeyValuePair<String, String> item in parameters)
            {
                str += item.Key + "=" + item.Value + "&";
            }

            str = str.Remove(str.Length - 1); // remove the '&' at the end

            return str;
        }

        public static bool ValidateServerCertificate(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors sslPolicyErrors)
        {
            // Note: In this example all certificates are accepted, whis is not save, of course.
            return true;
        }

    }
}
