﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WSI_sample
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Session session;
        Data data;
        bool details = false; // if true, the details are shown

        public MainWindow()
        {
            InitializeComponent();
            data = Data.getData();
            session = Session.getSession();
            DataContext = data;
            detailsView.DataContext = new CollectionViewSource { Source = data.ListMessages };
        }

        private void btnLogin_Click(object sender, RoutedEventArgs e)
        {
            if (textBoxServerAddress.Text == "" || textBoxUser.Text == "")
            {
                MessageBox.Show("Server address and user ID required", "Missing value", MessageBoxButton.OK);
            }
            else
            {
                // store user data in the data instance
                data.ServerAddress = textBoxServerAddress.Text;
                data.UserId = textBoxUser.Text;
                data.Password = textBoxPassword.Password;
                data.Protocol = cmbProtocol.SelectedValue.ToString();

                // call the login method
                session.login();
            }

        }

        private void btnLogout_Click(object sender, RoutedEventArgs e)
        {
            // call the logout method
            session.logout();
        }

        private void btnDetails_Click(object sender, RoutedEventArgs e)
        {
            if (details)
            {
                detailsView.Visibility = Visibility.Collapsed;
                details = false;
                
            }
            else
            {
                detailsView.Visibility = Visibility.Visible;
                details = true;
            }
            
        }
    }
}
