﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WSI_sample
{
    /*
     * This class represents one request that was made to the WSI.
     */
    class Message
    {
        private String url;         // requested URL
        private String response;    // response of the WSI
        private Command command;    // the command used in this request

        public enum Command
        {
            Login,
            Logout,
            EventStart,
            GetEvents,
            GetDeviceState
        };

        public Message(Message.Command cmd, String url, String response)
        {
            this.url = url;
            this.response = response;
            this.command = cmd;
        }

        public override string ToString()
        {
            return command + ": " + url;
        }

        public String getUrl()
        {
            return url;
        }

        public String Response
        {
            get { return response; }
            set { response = value; }
        }
    }
}
