﻿using System;
using System.IO;
using System.Text;
using System.Xml;

namespace WSI_sample
{
    class Tools
    {
        /*
         * Formats a XML string.
         */
        public static String formatXml(String input, int indent)
        {
            MemoryStream stream = new MemoryStream();
            XmlTextWriter writer = new XmlTextWriter(stream, Encoding.Unicode);
            XmlDocument xml = new XmlDocument();
            String formatted;

            try
            {
                xml.LoadXml(input);
                writer.Formatting = Formatting.Indented;
                writer.Indentation = 3;

                xml.WriteContentTo(writer);
                writer.Flush();
                stream.Flush();

                stream.Position = 0;

                StreamReader sReader = new StreamReader(stream);

                formatted = sReader.ReadToEnd();
            }
            catch (Exception e)
            {
                return input;
            }

            return formatted;
        }

        /*
         * Formats a JSON string.
         */
        public static String formatJson(String input)
        {
            String formatted = "";
            int offset = 0;
            char current;
            bool indent = true;

            for (int i = 0; i < input.Length; i++)
            {
                current = input[i];
                switch (current)
                {
                    case '[':
                    case '{':
                        if (offset == 0)
                            formatted += getIndent(offset) + current;
                        else
                            formatted += "\n" + getIndent(offset) + current;
                        ++offset;
                        indent = true;
                        break;
                    case ']':
                    case '}':
                        formatted += "\n" + getIndent(offset - 1) + current;
                        --offset;
                        indent = true;
                        break;
                    case ',':
                        formatted += current;
                        indent = true;
                        break;
                    default:
                        if (indent)
                        {
                            formatted += "\n" + getIndent(offset);
                        }
                        formatted += current;
                        indent = false;
                        break;
                }
            }

            return formatted;
        }

        public static string getIndent(int offset)
        {
            string str = "";
            for (int i = 0; i < offset; i++)
                str += "   ";
            return str;
        }
    }
}
